/**
* Eliminación.
*
* Autor: Ángel Martínez de las Heras
*/

-- Eliminar jobs
BEGIN
    DBMS_SCHEDULER.DROP_JOB(job_name => 'dailyAuditCountUpdate');
END;
/
BEGIN
    DBMS_SCHEDULER.DROP_JOB(job_name => 'CHECK_CREATE_YEARLY_RE_YEAR_JOB');
END;
/

-- Eliminar procedimientos
DROP PROCEDURE addApplication;
DROP PROCEDURE launchApplication;
DROP PROCEDURE updateApplication;
DROP PROCEDURE endApplicationLifeCycle;
DROP PROCEDURE addGeographicZone;
DROP PROCEDURE addApproverRole;
DROP PROCEDURE addArea;
DROP PROCEDURE addApprover;
DROP PROCEDURE assignSubstituteToApprover;
DROP PROCEDURE addUnavailability;
DROP PROCEDURE setApproverAvailability;
DROP PROCEDURE addApplicationApprover;
DROP PROCEDURE addChangeCategory;
DROP PROCEDURE deleteChangeCategory;
DROP PROCEDURE addChange;
DROP PROCEDURE rejectChange;
DROP PROCEDURE approveChange;
DROP PROCEDURE vote;
DROP PROCEDURE addComment;
DROP PROCEDURE executeChange;
DROP PROCEDURE addAction;
DROP PROCEDURE closeAction;
DROP PROCEDURE closeActionPlan;
DROP PROCEDURE addProcessAudit;
DROP PROCEDURE addAuditComment;
DROP PROCEDURE updateLastSixMonthsAuditCount;
DROP PROCEDURE checkAndCreateCurrentYearREYear;

-- Eliminar triggers
DROP TRIGGER trg_application_id;
DROP TRIGGER trg_geographiczone_id;
DROP TRIGGER trg_approverrole_id;
DROP TRIGGER trg_area_id;
DROP TRIGGER trg_approver_id;
DROP TRIGGER trg_unavailability_id;
DROP TRIGGER trg_changecategory_id;
DROP TRIGGER trg_change_id;
DROP TRIGGER trg_changeexecution_id;
DROP TRIGGER trg_actionplan_id;
DROP TRIGGER trg_action_id;
DROP TRIGGER trg_processaudit_id;
DROP TRIGGER trg_auditcomment_id;
DROP TRIGGER trg_logprocedure_id;

-- Eliminar índices
DROP INDEX idx_application_geographiczone;
DROP INDEX idx_application_technicalcontact;
DROP INDEX idx_application_businesscontact;
DROP INDEX idx_approver_approverrole;
DROP INDEX idx_approver_area;
DROP INDEX idx_approver_substitute;
DROP INDEX idx_unavailability_approver;
DROP INDEX idx_approval_approver;
DROP INDEX idx_approval_change;
DROP INDEX idx_applicationapprovers_application;
DROP INDEX idx_applicationapprovers_approver;
DROP INDEX idx_change_changecategory;
DROP INDEX idx_change_application;
DROP INDEX idx_changeexecution_change;
DROP INDEX idx_actionplan_changeexecution;
DROP INDEX idx_action_actionplan;
DROP INDEX idx_auditcomment_processaudit;

-- Eliminar sequencias
DROP SEQUENCE seq_application_id;
DROP SEQUENCE seq_geographiczone_id;
DROP SEQUENCE seq_approverrole_id;
DROP SEQUENCE seq_area_id;
DROP SEQUENCE seq_approver_id;
DROP SEQUENCE seq_unavailability_id;
DROP SEQUENCE seq_changecategory_id;
DROP SEQUENCE seq_change_id;
DROP SEQUENCE seq_changeexecution_id;
DROP SEQUENCE seq_actionplan_id;
DROP SEQUENCE seq_action_id;
DROP SEQUENCE seq_processaudit_id;
DROP SEQUENCE seq_auditcomment_id;
DROP SEQUENCE seq_logprocedure_id;

-- Eliminar tablas
DROP TABLE RE_Year;
DROP TABLE RE_Geographic;
DROP TABLE RE_LastSixMonths;
DROP TABLE LogProcedure;
DROP TABLE AuditComment;
DROP TABLE ProcessAudit;
DROP TABLE Action;
DROP TABLE ActionPlan;
DROP TABLE ChangeExecution;
DROP TABLE Approval;
DROP TABLE Unavailability;
DROP TABLE ApplicationApprovers;
DROP TABLE Change;
DROP TABLE ChangeCategory;
DROP TABLE Application;
DROP TABLE Approver;
DROP TABLE Area;
DROP TABLE ApproverRole;
DROP TABLE GeographicZone;

-- Eliminar tablespaces
DROP TABLESPACE RE_DATA INCLUDING CONTENTS AND DATAFILES CASCADE CONSTRAINTS;
DROP TABLESPACE IDX_DATA INCLUDING CONTENTS AND DATAFILES CASCADE CONSTRAINTS;
