/**
* Creación de index para FK.
*
* Autor: Ángel Martínez de las Heras
*/

CREATE INDEX idx_application_geographiczone ON Application(geographicZoneID) TABLESPACE IDX_DATA;
CREATE INDEX idx_application_technicalcontact ON Application(technicalContact) TABLESPACE IDX_DATA;
CREATE INDEX idx_application_businesscontact ON Application(businessContact) TABLESPACE IDX_DATA;

CREATE INDEX idx_approver_approverrole ON Approver(approverRoleID) TABLESPACE IDX_DATA;
CREATE INDEX idx_approver_area ON Approver(areaID) TABLESPACE IDX_DATA;
CREATE INDEX idx_approver_substitute ON Approver(substituteID) TABLESPACE IDX_DATA;

CREATE INDEX idx_unavailability_approver ON Unavailability(approverID) TABLESPACE IDX_DATA;

CREATE INDEX idx_approval_approver ON Approval(approverID) TABLESPACE IDX_DATA;
CREATE INDEX idx_approval_change ON Approval(changeID) TABLESPACE IDX_DATA;

CREATE INDEX idx_applicationapprovers_application ON ApplicationApprovers(applicationID) TABLESPACE IDX_DATA;
CREATE INDEX idx_applicationapprovers_approver ON ApplicationApprovers(approverID) TABLESPACE IDX_DATA;

CREATE INDEX idx_change_changecategory ON Change(changeCategoryID) TABLESPACE IDX_DATA;
CREATE INDEX idx_change_application ON Change(applicationID) TABLESPACE IDX_DATA;

CREATE INDEX idx_changeexecution_change ON ChangeExecution(changeID) TABLESPACE IDX_DATA;

CREATE INDEX idx_actionplan_changeexecution ON ActionPlan(changeExecutionID) TABLESPACE IDX_DATA;

CREATE INDEX idx_action_actionplan ON Action(actionPlanID) TABLESPACE IDX_DATA;

CREATE INDEX idx_auditcomment_processaudit ON AuditComment(auditID) TABLESPACE IDX_DATA;
