/**
* Creación de triggers.
*
* Autor: Ángel Martínez de las Heras
*/

-- Triggers para la PK
CREATE OR REPLACE TRIGGER trg_application_id
BEFORE INSERT ON Application
FOR EACH ROW
BEGIN
  SELECT seq_application_id.NEXTVAL
  INTO :new.IDApplication
  FROM dual;
END;
/

CREATE OR REPLACE TRIGGER trg_geographiczone_id
BEFORE INSERT ON GeographicZone
FOR EACH ROW
BEGIN
  SELECT seq_geographiczone_id.NEXTVAL
  INTO :new.IDZone
  FROM dual;
END;
/

CREATE OR REPLACE TRIGGER trg_approverrole_id
BEFORE INSERT ON ApproverRole
FOR EACH ROW
BEGIN
  SELECT seq_approverrole_id.NEXTVAL
  INTO :new.IDRole
  FROM dual;
END;
/

CREATE OR REPLACE TRIGGER trg_area_id
BEFORE INSERT ON Area
FOR EACH ROW
BEGIN
  SELECT seq_area_id.NEXTVAL
  INTO :new.IDArea
  FROM dual;
END;
/

CREATE OR REPLACE TRIGGER trg_approver_id
BEFORE INSERT ON Approver
FOR EACH ROW
BEGIN
  SELECT seq_approver_id.NEXTVAL
  INTO :new.IDApprover
  FROM dual;
END;
/

CREATE OR REPLACE TRIGGER trg_unavailability_id
BEFORE INSERT ON Unavailability
FOR EACH ROW
BEGIN
  SELECT seq_unavailability_id.NEXTVAL
  INTO :new.IDUnavailability
  FROM dual;
END;
/

CREATE OR REPLACE TRIGGER trg_changecategory_id
BEFORE INSERT ON ChangeCategory
FOR EACH ROW
BEGIN
  SELECT seq_changecategory_id.NEXTVAL
  INTO :new.IDCategory
  FROM dual;
END;
/

CREATE OR REPLACE TRIGGER trg_change_id
BEFORE INSERT ON Change
FOR EACH ROW
BEGIN
  SELECT seq_change_id.NEXTVAL
  INTO :new.IDChange
  FROM dual;
END;
/

CREATE OR REPLACE TRIGGER trg_changeexecution_id
BEFORE INSERT ON ChangeExecution
FOR EACH ROW
BEGIN
  SELECT seq_changeexecution_id.NEXTVAL
  INTO :new.IDExecution
  FROM dual;
END;
/

CREATE OR REPLACE TRIGGER trg_actionplan_id
BEFORE INSERT ON ActionPlan
FOR EACH ROW
BEGIN
  SELECT seq_actionplan_id.NEXTVAL
  INTO :new.IDActionPlan
  FROM dual;
END;
/

CREATE OR REPLACE TRIGGER trg_action_id
BEFORE INSERT ON Action
FOR EACH ROW
BEGIN
  SELECT seq_action_id.NEXTVAL
  INTO :new.IDAction
  FROM dual;
END;
/

CREATE OR REPLACE TRIGGER trg_processaudit_id
BEFORE INSERT ON ProcessAudit
FOR EACH ROW
BEGIN
  SELECT seq_processaudit_id.NEXTVAL
  INTO :new.IDAudit
  FROM dual;
END;
/

CREATE OR REPLACE TRIGGER trg_auditcomment_id
BEFORE INSERT ON AuditComment
FOR EACH ROW
BEGIN
  SELECT seq_auditcomment_id.NEXTVAL
  INTO :new.IDComment
  FROM dual;
END;
/

CREATE OR REPLACE TRIGGER trg_logprocedure_id
BEFORE INSERT ON LogProcedure
FOR EACH ROW
BEGIN
  SELECT seq_logprocedure_id.NEXTVAL
  INTO :new.IDLog
  FROM dual;
END;
/




