/**
* Pruebas de datos.
*
* Autor: Ángel Martínez de las Heras
*/

-- Para que RSP se muestre por consola:
SET serveroutput ON;

--Iniciar tabla RE_Year
INSERT INTO RE_Year (yearData, changesInApproval, incorrectExecution, 
    maxCorrectChangesTechnicalManager, doneActionsInTimePercentaje, 
    GCABApprovedChanges, notApprovedChanges, openActionPlans, 
    maxOpenChangesTechnicalManager, mostReplacedApprover) 
        VALUES (EXTRACT(YEAR FROM SYSDATE), 0, 0, NULL, NULL, 0, 0, 0, NULL, NULL);


/**
* 5.1 Adición de aprobadores
*/
-- Add ApproverRole
DECLARE RSP VARCHAR2(1000);
BEGIN
    -- Correct
    addApproverRole('Technical Manager', 10, 1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApproverRole('Business area responsible', 20, 1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApproverRole('Change Manager', 40, 1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApproverRole('GCAB with vote', 30, 1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApproverRole('GCAB without vote', 30, 0, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    -- Incorrect
    addApproverRole('Guest', 50, NULL, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApproverRole('Guest', 110, 0, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- Add areas
DECLARE RSP VARCHAR2(1000);
BEGIN
-- Correct
    addArea('Development', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addArea('IoT', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addArea('Data', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addArea('Administration', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    -- Incorrect
    addArea(NULL, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- Add approvers App 1
DECLARE RSP VARCHAR2(1000);
BEGIN
    -- Correct
    addApprover('John Doe', 'john.doe@example.com', 1, 1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApprover('Jane Smith', 'jane.smith@example.com', 2, 4, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApprover('Alice Johnson', 'alice.johnson@example.com', 3, 4, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApprover('Bob Brown', 'bob.brown@example.com', 4, 4, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApprover('Carlos Green', 'carlos.green@example.com', 4, 1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApprover('Emma White', 'emma.white@example.com', 5, 3, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    -- Substitutes
    addApprover('Michael Harris', 'michael.harris@example.com', 3, 4, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApprover('Sarah Wilson', 'sarah.wilson@example.com', 2, 4, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApprover('Linda Martinez', 'linda.martinez@example.com', 4, 1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApprover('Jane Brown', 'jane.brown@example.com', 1, 1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApprover('Bob Martinez', 'bob.martinez@example.com', 4, 4, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    -- Incorrect
    addApprover('Charles Skies', 'c.skies@example.org', 99, 99, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApprover('Charles Skies', 'c.skies@example.org', 1, 10000, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApprover(NULL, 'no.name@example.com', 1, 1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- Add approvers App 2
DECLARE RSP VARCHAR2(1000);
BEGIN
    -- App 2
    addApprover('James Wilson', 'james.wilson@example.com', 1, 3, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApprover('Patricia Brown', 'patricia.brown@example.com', 2, 4, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApprover('David Garcia', 'david.garcia@example.com', 3, 3, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApprover('Susan Anderson', 'susan.anderson@example.com', 4, 2, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApprover('Joseph Miller', 'joseph.miller@example.com', 4, 1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApprover('Margaret Taylor', 'margaret.taylor@example.com', 5, 4, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    -- Substitutes
    addApprover('Charles Moore', 'charles.moore@example.com', 1, 3, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApprover('Barbara Jackson', 'barbara.jackson@example.com', 2, 4, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApprover('William White', 'william.white@example.com', 3, 3, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApprover('Charles Skies', 'charles.skies@example.com', 4, 2, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApprover('Patricia Smith', 'patricia.smith@example.com', 4, 1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- Asignación de sustitutos.
DECLARE RSP VARCHAR2(1000);
BEGIN
    -- Correct
    assignSubstituteToApprover(3, 7, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    assignSubstituteToApprover(2, 8, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    assignSubstituteToApprover(5, 9, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    assignSubstituteToApprover(1, 10, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    assignSubstituteToApprover(4, 11, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    assignSubstituteToApprover(15, 21, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    assignSubstituteToApprover(16, 22, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    assignSubstituteToApprover(17, 23, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    assignSubstituteToApprover(18, 24, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    assignSubstituteToApprover(19, 25, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    -- Incorrect
    assignSubstituteToApprover(56, 25, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    assignSubstituteToApprover(6, 56, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    assignSubstituteToApprover(1, null, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    assignSubstituteToApprover(null, 1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    assignSubstituteToApprover(6, 25, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

/**
* 5.2 Adición de aplicaciones
*/
-- Add GeographicZone
DECLARE RSP VARCHAR2(1000);
BEGIN
    -- Correct
    addGeographicZone('North America', 'Region covering USA and Canada', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addGeographicZone('Europe', 'Region covering EU countries', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addGeographicZone('Asia Pacific', 'Region covering China, India, Japan, etc.', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    -- Incorrect
    addGeographicZone(NULL, 'Africa', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- Add Applications
DECLARE
    RSP VARCHAR2(1000);
BEGIN
    -- Correct
    addApplication('Finance App - Molex', 500, 'Java', 'Cloud', 'Alta', 1, 1, 2, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApplication('Data Scramble', NULL, 'Python', 'On-Premise', 'Media', 2, 15, 16, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    -- Incorrect
    addApplication(NULL, 500, 'Java', 'Cloud', 'Alta', 1, 1, 2, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApplication('App Inexistente', 500, 'Java', 'Cloud', 'Alta', 9999, 1, 2, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApplication('App sin Contacto técnico', 500, 'Java', 'Cloud', 'Alta', 1, NULL, 2, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

/**
* 5.3 Asignación de aprobadores a aplicaciones
*/
-- addApplicationApprover
DECLARE
    RSP VARCHAR2(1000);
BEGIN
    -- Correct
    addApplicationApprover(1, 1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApplicationApprover(1, 2, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApplicationApprover(1, 3, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApplicationApprover(1, 4, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApplicationApprover(1, 5, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApplicationApprover(1, 6, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApplicationApprover(2, 15, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApplicationApprover(2, 16, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApplicationApprover(2, 17, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApplicationApprover(2, 18, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApplicationApprover(2, 19, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addApplicationApprover(2, 20, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    -- Incorrect
    addApplicationApprover(3, 21, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- Add Unavailabilities
DECLARE
    RSP VARCHAR2(1000);
BEGIN
    -- Correct
    addUnavailability(1, 1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addUnavailability(17, 1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addUnavailability(4, 0, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    -- Incorrect
    addUnavailability(8, 2, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addUnavailability(1000, 1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- Add Availabilities
DECLARE
    RSP VARCHAR2(1000);
BEGIN
    -- Correct
    setApproverAvailability(1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    -- Incorrect
    setApproverAvailability(NULL, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- Add unavailabilites y availabilities for RE testing
DECLARE
    RSP VARCHAR2(1000);
BEGIN
    setApproverAvailability(17, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    setApproverAvailability(4, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/
DECLARE
    RSP VARCHAR2(1000);
BEGIN
    addUnavailability(17, 0, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addUnavailability(4, 1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/
DECLARE
    RSP VARCHAR2(1000);
BEGIN
    setApproverAvailability(17, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    setApproverAvailability(4, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/
DECLARE
    RSP VARCHAR2(1000);
BEGIN
    addUnavailability(17, 0, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addUnavailability(4, 1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

/**
* 5.4 Adición de cambios
*/
-- Add ChangeCategories
DECLARE
    RSP VARCHAR2(1000);
BEGIN
    --Correct
    addChangeCategory('Critical Change', 10, TO_DATE('2023-11-01', 'YYYY-MM-DD'), RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addChangeCategory('Minor Change', 30, TO_DATE('2023-11-03', 'YYYY-MM-DD'), RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addChangeCategory('Standard Change', 20, TO_DATE('2023-11-03', 'YYYY-MM-DD'), RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addChangeCategory('Test Change', 40, TO_DATE('2023-11-07', 'YYYY-MM-DD'), RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    --Incorrect
    addChangeCategory('Incomplete Change', 25, NULL, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- Launch Applications
DECLARE
    RSP VARCHAR2(1000);
BEGIN
    -- Correct
    launchApplication(1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    launchApplication(2, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    -- Incorrect
    launchApplication(NULL, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    launchApplication(5, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- Add Changes
DECLARE
    RSP VARCHAR2(1000);
BEGIN
    -- Correct
    addChange('Security patch under DF10012', 1, 1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addChange('Minor authentication update', 2, 2, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addChange('Login update for Google SSO', 3, 1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    -- Incorrect
    addChange('Invalid App change', 4, 10000, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

/**
* 5.5 Aprobación de cambio
*/
-- Add Approvals Change 1
DECLARE 
    RSP VARCHAR2(1000);
BEGIN
    -- votes
        -- Correct
        vote(1, 1, 1, 'Aprobado para producción', RSP);
        DBMS_OUTPUT.PUT_LINE(RSP);
        vote(2, 1, 1, 'Entiendo la urgencia', RSP);
        DBMS_OUTPUT.PUT_LINE(RSP);
        vote(11, 1, 1, 'Aprobado con observaciones menores', RSP); -- Sustituto
        DBMS_OUTPUT.PUT_LINE(RSP);
        vote(5, 1, 1, NULL, RSP);
        DBMS_OUTPUT.PUT_LINE(RSP);
        vote(3, 1, 1, 'Aprobado con observaciones menores', RSP);
        DBMS_OUTPUT.PUT_LINE(RSP);
        -- Incorrect
        vote(4, 1, 1, 'Aprobado con observaciones menores', RSP); -- No disponible
        DBMS_OUTPUT.PUT_LINE(RSP);
        vote(6, 1, 1, 'Approver sin voto', RSP);
        DBMS_OUTPUT.PUT_LINE(RSP);
        vote(7, 1, 1, 'Approver sin autorización', RSP);
        DBMS_OUTPUT.PUT_LINE(RSP);
        vote(1, 10000, 1, 'Change inexistente', RSP);
        DBMS_OUTPUT.PUT_LINE(RSP);
    -- comments
        addComment(6, 1, 'Empeorará la respuesta de la aplicación al aumentar x3 la cantidad de peticiones necesarias', RSP);
        DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- approveChange Change 1
DECLARE 
    RSP VARCHAR2(1000);
BEGIN
    --Correct
    approveChange(1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    -- Incorrect
    approveChange(1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    approveChange(1000, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

/**
* 5.6 Rechazo de cambio
*/
-- Add Approvals App 2
DECLARE 
    RSP VARCHAR2(1000);
BEGIN
    -- votes
    vote(15, 2, 1, 'Aprobado para producción', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    vote(16, 2, 1, 'Es una necesidad transmitida por el cliente', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    vote(23, 2, 0, 'Rechazado por falta de documentación', RSP);-- Sustituto
    DBMS_OUTPUT.PUT_LINE(RSP);
    -- comments
    addComment(20, 2, 'No tenemos documentación que analizar', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    --Incorrect
    addComment(20, 1, 'No tenemos documentación que analizar', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- rejectChange Change 2
DECLARE 
    RSP VARCHAR2(1000);
BEGIN
    --Correct
    rejectChange(2, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    -- Incorrect
    rejectChange(2, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    rejectChange(1000, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

/**
* 5.7 Ejecución de cambio
*/
-- executeChange Change 1
DECLARE 
    RSP VARCHAR2(1000);
BEGIN
    --Correct
    executeChange(1, TO_DATE('2023-12-09', 'YYYY-MM-DD'), 'correct', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    -- Incorrect
    executeChange(1, TO_DATE('2023-12-09', 'YYYY-MM-DD'), 'correcto', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

/**
* 5.8 Cambio replanificado para modificación de App
*/
-- Add Change for editing App 2
DECLARE
    RSP VARCHAR2(1000);
BEGIN
    addChange('Transfer to AWS cloud', 3, 2, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- Add Approvals Change 5
DECLARE 
    RSP VARCHAR2(1000);
BEGIN
    -- votes
        -- Correct
        vote(15, 5, 1, NULL, RSP);
        DBMS_OUTPUT.PUT_LINE(RSP);
        vote(16, 5, 1, NULL, RSP);
        DBMS_OUTPUT.PUT_LINE(RSP);
        vote(18, 5, 1, NULL, RSP);
        DBMS_OUTPUT.PUT_LINE(RSP);
        vote(19, 5, 1, NULL, RSP);
        DBMS_OUTPUT.PUT_LINE(RSP);
        vote(23, 5, 1, 'Aprobado en sustitución', RSP); -- Sustituto
        DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- approveChange Change 5
DECLARE 
    RSP VARCHAR2(1000);
BEGIN
    approveChange(5, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- executeChange Change 5 - ChangeExecution 2
DECLARE 
    RSP VARCHAR2(1000);
BEGIN
    executeChange(2, TO_DATE('2023-12-10', 'YYYY-MM-DD'), 'rescheduled', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- addAction
DECLARE 
    RSP VARCHAR2(1000);
BEGIN
    addAction('Subir el 2023-12-11 ya que se encuentra actualmente terminando un proceso', TO_DATE('2023-12-11', 'YYYY-MM-DD'), 1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- closeAction
DECLARE 
    RSP VARCHAR2(1000);
BEGIN
    closeAction(1, TO_DATE('2023-12-12', 'YYYY-MM-DD'), RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- closeActionPlan
DECLARE 
    RSP VARCHAR2(1000);
BEGIN
    closeActionPlan(1, 'Reprogramado', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- updateApplication
DECLARE
    RSP VARCHAR2(100);
BEGIN
    updateApplication(2,NULL, NULL, 'Cloud', NULL, NULL, NULL, NULL, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- executeChange Change 5 - ChangeExecution 3
DECLARE 
    RSP VARCHAR2(1000);
BEGIN
    executeChange(3, TO_DATE('2023-12-12', 'YYYY-MM-DD'), 'correct', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

/**
* 5.9 Nuevos cambios con diferentes situaciones
*/
-- New Change
DECLARE
    RSP VARCHAR2(1000);
BEGIN
    addChange('Major performance enhancement', 1, 1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- Votos
DECLARE 
    RSP VARCHAR2(1000);
BEGIN
    vote(1, 6, 1, 'Se espera un significativo incremento del rendimiento', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    vote(2, 6, 1, 'Me parece correcto', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    vote(11, 6, 1, NULL, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    vote(5, 6, 1, NULL, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    vote(3, 6, 1, 'Aprobado, asegurarse de monitorizar el rendimiento', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addComment(6, 6, 'Necesarias mayores comprobaciones en pre-producción', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- Approve Change 6
DECLARE 
    RSP VARCHAR2(1000);
BEGIN
    approveChange(6, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- executeChange Change 6 - ChangeExecution 4
DECLARE 
    RSP VARCHAR2(1000);
BEGIN
    executeChange(4, TO_DATE('2023-12-10', 'YYYY-MM-DD'), 'incidents', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- addActions
DECLARE 
    RSP VARCHAR2(1000);
BEGIN
    addAction('Comprobar librería', TO_DATE('2023-12-12', 'YYYY-MM-DD'), 2, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addAction('Comprobar funciones', TO_DATE('2023-12-13', 'YYYY-MM-DD'), 2, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addAction('Comprobar retrocompatibilidad', TO_DATE('2023-12-15', 'YYYY-MM-DD'), 2, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addAction('Monitorizar 24h', TO_DATE('2023-12-16', 'YYYY-MM-DD'), 2, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addAction('Adaptar servidor', TO_DATE('2023-12-20', 'YYYY-MM-DD'), 2, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addAction('Monitorizar en nuevo entorno', TO_DATE('2023-12-25', 'YYYY-MM-DD'), 2, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- closeAction
DECLARE 
    RSP VARCHAR2(1000);
BEGIN
    closeAction(2, TO_DATE('2023-12-12', 'YYYY-MM-DD'), RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    closeAction(3, TO_DATE('2023-12-13', 'YYYY-MM-DD'), RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    closeAction(4, TO_DATE('2023-12-16', 'YYYY-MM-DD'), RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    closeAction(5, TO_DATE('2023-12-17', 'YYYY-MM-DD'), RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/
-- El ActionPlan se queda abierto con dos Action pendientes

-- Otro Change para que queden pendientes
DECLARE
    RSP VARCHAR2(1000);
BEGIN
    addChange('Actualización de GUI a 3.2', 3, 1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addChange('Actualización de editor de texto', 3, 1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- Votes
DECLARE 
    RSP VARCHAR2(1000);
BEGIN
    vote(1, 7, 1, 'Mejora significativa en la usabilidad', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    vote(2, 7, 1, 'Conforme', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    vote(11, 7, 1, 'Compatible con nuestros estándares actuales', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    vote(5, 7, 1, NULL, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    vote(3, 7, 1, 'Es necesario revisar la compatibilidad con dispositivos móviles', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);

    vote(1, 8, 1, 'Cambio acorde a la actualización de GUI', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    vote(2, 8, 1, NULL, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    vote(11, 8, 1, NULL, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    vote(5, 8, 1, NULL, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    vote(3, 8, 1, 'Revisar la compatibilidad con dispositivos móviles', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/
DECLARE 
    RSP VARCHAR2(1000);
BEGIN
    approveChange(7, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    approveChange(8, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

/**
* 5.10 Baja de aplicación
*/
-- Cambio para dar de baja App 2
DECLARE
    RSP VARCHAR2(1000);
BEGIN
    addChange('Baja de aplicación', 3, 2, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

DECLARE 
    RSP VARCHAR2(1000);
BEGIN
    vote(15, 9, 1, 'Ha cumplido su ciclo', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    vote(16, 9, 1, 'Cliente conforme', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    vote(18, 9, 1, NULL, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    vote(19, 9, 1, NULL, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    vote(23, 9, 1, 'Ok', RSP); -- Sustituto
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

DECLARE 
    RSP VARCHAR2(1000);
BEGIN
    approveChange(9, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- endApplicationLifeCycle App 2
DECLARE 
    RSP VARCHAR2(1000);
BEGIN
    endApplicationLifeCycle(2, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- executeChange Change 9 - ChangeExecution 7
DECLARE 
    RSP VARCHAR2(1000);
BEGIN
    executeChange(7, TO_DATE('2023-12-16', 'YYYY-MM-DD'), 'correct', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

/**
* 5.11 Eliminado de categoría de cambio
*/
-- deleteChangeCategory
DECLARE
    RSP VARCHAR2(1000);
BEGIN
    deleteChangeCategory(4, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

/**
* 5.12 Auditorías
*/
-- Add Audit
DECLARE
    RSP VARCHAR2(1000);
BEGIN
    addProcessAudit('Auditoría completa con varias inconformidades detectadas.', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- Add Non Conformities
DECLARE
    RSP VARCHAR2(1000);
BEGIN
    addAuditComment('Incumplimiento de normas de seguridad', 'Se requiere revisión inmediata de protocolos.', 1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addAuditComment('Falta de documentación adecuada', 'Es necesario actualizar la documentación de procesos.', 1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    addAuditComment('Retrasos en la entrega de informes', 'Se observaron demoras significativas en la entrega de informes.', 1, RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

-- Add Audit sin incorformidades
DECLARE
    RSP VARCHAR2(1000);
BEGIN
    addProcessAudit('Auditoría completa sin inconformidades.', RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
END;
/
